% tveq_example.m
%
% Test out tveq code (TV minimization with equality constraints).
%
% Written by: Justin Romberg, Caltech
% Email: jrom@acm.caltech.edu
% Created: October 2005
%


%%%%%%%%%% NAPOMENE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% MAX DUZINA SIGNALA TREBA DA BUDE 4096, JER CE U SUPROTNOM DA
%%%%%%% ZAGLAVI


%%%%%%%%%%%%%% ZA SIGNAL DISANJA NE RADI!!!!!!!!!!!!!!!
% load RespirationMonitorADNormalnoIDubokloDisanje.mat
% num=RespirationMonitorADNormalnoIDubokloDisanje;
%num=num(5000:5000+4095,1);


%%%%%%%%%%%%% ZA OVE OSTALE SIGNALE RADI ALI NE TAKO DOBRO KAO SA DCT
% load eeg8s.mat
% num=eeg8s;

% % load EOG.mat;
% % num=data(:);
% % num=num(100000:4:116380,1);
% % 
%%%QRS kompeksi
% % % load 11950_03m.mat
% % % num=val';
% % % num=num(1:4096);

function [num_orig,num_rec,mse]=TVminDFT(num, procenat)
% use implicit, matrix-free algorithms ?  
largescale = 0;

path(path, './Optimization');
path(path, './Measurements');
path(path, './Data');

% num is signal
% percent is integer

VEL=sqrt(length(num));

num3=num(1:VEL*VEL);

slika=reshape(num3,VEL,VEL);
I=slika;
N=length(num3);
n=VEL;

norma=norm(I(:));
srednja=mean(I(:));

I = I/norm(I(:));
I = I - mean(I(:));
x = reshape(I,N,1);



% num obs
K = round(procenat*VEL*VEL/100);

% permutation P and observation set OMEGA
P = randperm(N)';
q = randperm(round(N/2)-1)+1;
OMEGA = q(1:K/2)';



% measurement matrix
if (largescale)
  A = @(z) A_f(z, OMEGA, P);
  At = @(z) At_f(z, N, OMEGA, P);
  % obsevations
  b = A(x);
  % initial point
  x0 = At(b);
else
  FT = 1/sqrt(N)*fft(eye(N));
  A = sqrt(2)*[real(FT(OMEGA,:)); imag(FT(OMEGA,:))];
  A = [1/sqrt(N)*ones(1,N); A];
  At = [];
  % observations
  b = A*x;
  % initial point
  x0 = A'*b;
end


tvI = sum(sum(sqrt([diff(I,1,2) zeros(n,1)].^2 + [diff(I,1,1); zeros(1,n)].^2 )));
disp(sprintf('Original TV = %.3f', tvI));

time0 = clock;
xp =  tveq_logbarrier(x0, A, At, b, 1e-3, 5, 1e-8, 200);
Ip = reshape(xp, n, n);
disp(sprintf('Total elapsed time = %f secs\n', etime(clock,time0)));

% Ip1=Ip*norma+srednja;
% num_rec=Ip1(:);

num_orig=x;
num_rec=xp;

mse=mean(abs(num_orig-num_rec).^2);

end





                                                                                                                                     
