%%%% napomena: X je slika, L je broj radijalnih linija u maski
%%%% slika treba prebaciti u gray, i treba da je dimenzija N^2xN^2

function [Xtv,time,PSNR]=algoritam1(X,L)

path(path, './Optimization');
path(path, './Measurements');
path(path, './Data');
 
n = 256;
N = n*n;
X=double(X);
x = X(:);

% Fourier samples we are given
[M,Mh,mh,mhi] = LineMask(L,n);
OMEGA = mhi;
A = @(z) A_fhp(z, OMEGA);
At = @(z) At_fhp(z, OMEGA, n);

% measurements
y = A(x);

% min l2 reconstruction (backprojection)
xbp = At(y);
Xbp = reshape(xbp,n,n);

% recovery
tic
tvI = sum(sum(sqrt([diff(X,1,2) zeros(n,1)].^2 + [diff(X,1,1); zeros(1,n)].^2 )));
disp(sprintf('Original TV = %8.3f', tvI));
xp = tveq_logbarrier(xbp, A, At, y, 1e-1, 2, 1e-8, 600);
% xp = tveq_logbarrier(xbp, A, At, y);
Xtv = reshape(xp, n, n);
time=toc
time

PSNR=20*log10((max(max(double(X))))./sqrt(mean(mean((double(X)-double(Xtv)).^2))));