
function Reconstructed=algoritam4_gradRec(X,Pnoise,B)
% Pnoise % Noisy samples ratio 
% X input RGB image
% B - DCT2 block size is B x B, e.g. B=64

RGB=X;

% tic

%Nz=7; % Max Nz nonzero DCT coefficients allowed in single block
Nz=B*B;


rng('default')
I = rgb2gray(RGB);

[M,N]=size(I);

% trim image according to block size
M=M-rem(M,B);
N=N-rem(N,B);
I=I(1:M,1:N);
RGB=RGB(1:M,1:N);


% compress image with up to Nz nonzero DCT coefficients in single block
R2=[];
for p=1:1
    I=RGB(:,:);
    Kmn=zeros(size(I));
    for m=0:M/B-1
        for n=0:N/B-1
            I2=I(m*B+(1:B),n*B+(1:B));
            I2_DCT=dct2(I2);
            [ddd,ind]=sort(-abs(I2_DCT(:)));
            I2_DCT(ind(Nz+1:end))=0;
            I2=idct2(I2_DCT);
            Kmn(m*B+(1:B),n*B+(1:B))=I2;
        end
    end
    R2(:,:)=Kmn;
end

% show image that is sparse in DCT2 domain (with blocks B x B)
% figure(2)
GG=R2;
GG(GG<0)=0;GG(GG>255)=255;GG=GG/255;

% add salt and peper noise 2
Nxx2={};
for m=0:M/B-1
    for n=0:N/B-1
        In=randperm(B*B);
        In=In(1:round(B*B*Pnoise));
        Nxx2{m+1,n+1}=In;
    end
end

Rn=R2;
R0=R2;

for m=0:M/B-1
    for n=0:N/B-1
        rrr=sign(rand(1,length(Nxx2{m+1,n+1}))-.5);
        for p=1:1
            I2=R2(m*B+(1:B),n*B+(1:B));
            I2(Nxx2{m+1,n+1})=255;
            R0(m*B+(1:B),n*B+(1:B))=I2;
            I2(Nxx2{m+1,n+1})=127*rrr+128;
            Rn(m*B+(1:B),n*B+(1:B))=I2;
        end
    end
end

figure(5)
  
GG=Rn;
GG(GG<0)=0;GG(GG>255)=255;GG=GG/255;
GG=R0;
GG(GG<0)=0;GG(GG>255)=255;GG=GG/255;
% imshow(GG)
% title(['Reconstructed image.  Iteration: ',sprintf('%3d',0)])



IHH=2;
for Nit=[100]
    for p=1:3
        % Reconstruction
        warning off MATLAB:GradRec
        %Nit=3;
        KmnREC=R0(:,:);
        for m=0:M/B-1
            for n=0:N/B-1
                I2=KmnREC(m*B+(1:B),n*B+(1:B));
                [I2,it,An]=GradRec(I2,Nxx2{m+1,n+1},{@dct2,sqrt(1000)},128,Nit);
                KmnREC(m*B+(1:B),n*B+(1:B))=I2;
            end
        end
        RR(:,:)=KmnREC;
    end
    GG=RR;


R0=round(R0);
RR=round(RR);
% % % ime1=strcat(num2str(niz(io)),'_rec_16(128)_30percent.mat');
% % % save (ime1,'RR')
% % % 
% % % ime2=strcat(num2str(niz(io)),'_missing_16(128)_30percent.mat');
% % % save (ime2,'R0')
% % % 
% % % ime3=strcat(num2str(niz(io)),'_orig_16(128)_30percent.mat');
% % % save (ime3,'RGB')

end

Reconstructed=uint8(RR(:,:));
% % % figure,imshow(Reconstructed), title('Reconstructed image')
% % % figure,imshow(I), title('Original image')
% % % disp(sprintf('CS PSNR = %5.2f', psnr(Reconstructed,I)));


% % % figure,imagesc(abs(RR)), axis off, title('Reconstructed image'), colormap(1-gray)
% % % figure,imagesc(abs(RGB)), axis off, title('Original image'), colormap(1-gray)
% % % figure,imagesc(abs(R0)), axis off, title('Image with missing samples'), colormap(1-gray)