% clear all
% close all

function [slika,Slika_rec, PSNR]=algoritam5slika(num, K1, K2);

%%% num - originalni signal
%%% num_orig - originalni signal podesen za crtanje
%%% K1 - procenat niskofrekvencijskih DCT koeficijenata koji se uzimaju
%%% K2 - procenat ostalih DCT koeficijenata koji se uzimaju
%%% num_rec - rekonstruisani signal


%%%%% ALGORITAM RADI TAKO STO UZIMA ODREDJENI BROJ NISKO-FREKVENCIJSKIH
%%%%% KOEFICIJENATA (K1) i ODREDJENI BROJ SREDNJE I VISOKO-FREKVENCIJSKIH
%%%%% KOEFICIJENATA (K2)



addpath ./Measurements
addpath ./Optimization
addpath ./Utils
xx=5;
yy=5;
font_size=7;
VEL=128;


%%%% NEKI OD SIGNALA:

%%%QRS kompeksi
% load 11950_03m.mat
% % num=val(1460:1502)';
% num=val';

% load HeartSoundsMicrophoneAD_2.mat
% num=HeartSoundsMicrophoneAD_2;

% load PulsePlethysmographAD_2.mat
% num=PulsePlethysmographAD_2;

% load RespirationMonitorADNormalnoIDubokloDisanje.mat
%  num=RespirationMonitorADNormalnoIDubokloDisanje;

% load SphygmomanometerAndHeartSoundMeterAD_2.mat
% num=SphygmomanometerAndHeartSoundMeterAD_2;

%%%% PODESAVANJA SIGNALA (radi isto ovo podesavanje za svaki od gore navedenih signala):
num1=10^4*num(995+1:4206+1);

% % % num1=num(1147:1592);

% num3=[0*mean(num1)*ones(round((VEL*VEL-length(num1))/2),1);num1;0*mean(num1)*ones(round((VEL*VEL-length(num1))/2),1)];
% slika=reshape(num3,VEL,VEL);
slika=num;
figure,imshow(slika)


[M,N]=size(slika);

X=double(slika);
x = X(:);
ncs = size(X,1);
Ncs = ncs*ncs;

% % % for linear approximation
lporder = bdct_linapprox_ordering(ncs, ncs);
% % % low pass DCT2, K1 = number of lowpass coefficients

K1 = round(K1*M*N/100);
OM1 = lporder(1:K1);

% % % for random projection, avoid mean
q = randperm(Ncs)';  
% % % K2 = number of auxiliary measurements
% % %  (either noiselet or more dct2)
K2 = round(45*M*N/100);  
OM2 = q(1:K2);
Phi = @(z) A_lpnlet(z, ncs, OM1, OM2); 
Phit = @(z) At_lpnlet(z, ncs, OM1, OM2);  


% % % take measurements
 y = Phi(x); %% 

  
% % % min l2 for cs
PPt = @(z) Phi(Phit(z));
x0 = Phit(cgsolve(PPt, y, 1e-8, 200)); %% Solve a symmetric positive definite system Ax = b via conjugate gradients. %%
%   

% % % parameters for optimization code 
lbtol = 918;     % 1e-3*tv(X);
mu = 10;
cgtol = 1e-6;
cgmaxiter = 800;



t000 = clock; %%% returns a six element date vectoc, vector containing the current time and date in decimal form

% % % cs recovery
epsilon = 1e-3*norm(y);
t000 = clock;
% % % Solve quadractically constrained TV minimization
% % % min TV(x)  s.t.  ||Ax-b||_2 <= epsilon.
xp = tvqc_logbarrier(x0, Phi, Phit, y, epsilon, lbtol, mu, cgtol, cgmaxiter);
t111 = clock;
disp(sprintf('Elapsed time = %8.2f seconds', etime(t111,t000)));
Xp = reshape(xp, ncs, ncs);

 
disp(sprintf('\n'));
disp(sprintf('K = %d + %d = %d', K1, K2, K1+K2));
disp(sprintf('CS PSNR = %5.2f', psnr(X,Xp)));
disp(sprintf('\n\n'));

PSNR=psnr(X,Xp);

Slika_rec=Xp;

num_orig=slika(:);
num_rec=Slika_rec(:);



num_orig_2=num_orig(VEL*VEL/2-length(num1)/2:VEL*VEL/2+length(num1)/2,1);
num_rec_2=num_rec(VEL*VEL/2-length(num1)/2:VEL*VEL/2+length(num1)/2,1);


end

        
